! Mdulo aleat.h 1.2 para Inform
! (C) El Presi (Enrique D. Bosch) [kifcu@confluencia.net]
! Puede distribuirse libremente bajo licencia GNU LGPL
!
! Proporciona nmeros pseudoaleatorios con aceso a su semilla
! y otros parmetros
!
! Compatible con Z y GLULX (biplataforma)
!
! Se pueden uno o ms objetos de la clase generador en el programa
! principal y acceder mediante los mtodos, csemilla, msemilla y
! pcriticos

message "Mdulo de pseudoaleatorios (aleat.h) 1.2 de El Presi";

system_file;

#ifndef WORDSIZE;
constant WORDSIZE=2;
constant TARGET_ZCODE;
#endif;


class generador
 private             ! parmetros crticos
   semilla 21027,
   mul 25173,        ! multiplicador
   sum 13849,        ! sumando
   mod 32766,        ! mdulo
   absmu
    [x;                       ! funcin de valor absoluto modificada
     if (x<0) return -x+1;    ! para mejorar aleatoriedad, necesaria
     return x;                ! por limitacin de clculo de la mquina Z
    ],
 with
   randomsem
    [ a z;               ! meollo del mtodo de congruencia lineal
     if (a==0) z++;
     self.semilla=((self.mul*self.semilla+self.sum)%self.mod);
#ifdef TARGET_ZCODE;
     return ((self.absmu(self.semilla))%z)+a;
#ifnot; ! TARGET_GLULX
     return (self.semilla%z)+a;
#endif; ! TARGET_
    ],
   csemilla
    [ x;                  ! cambiar semilla
     self.semilla=x;
    ],
   msemilla
    [;                    ! miarar semilla
     return self.semilla;
    ],
   pcriticos
    [ u s m;              ! cambiar parmetros crticos
     self.mul=u;
     self.sum=s;
     self.mod=m;
    ];
